﻿using System;
using System.Threading;

using Mischel.Synchronization;

namespace MultiThread
{
    class Program
    {
        static void Main(string[] args)
        {
            int numThreads = 4;
            WaitableTimer resourceTimer = new WaitableTimer(false, TimeSpan.FromSeconds(1), 1000);
            try
            {
                // start threads
                Thread[] threads = new Thread[numThreads];
                for (int i = 0; i < numThreads; ++i)
                {
                    Thread t = new Thread(() =>
                    {
                        Console.WriteLine("Thread {0} started", Thread.CurrentThread.ManagedThreadId);
                        for (int x = 0; x < 10; ++x)
                        {
                            resourceTimer.WaitOne();
                            Console.WriteLine("Thread {0}: {1}", Thread.CurrentThread.ManagedThreadId, x);
                            // Simulate doing some work
                            Thread.Sleep(1200);
                        }
                        Console.WriteLine("Thread {0} exit", Thread.CurrentThread.ManagedThreadId);
                    });
                    threads[i] = t;
                    t.Start();
                }
                Console.WriteLine("Threads started.  Waiting for all to exit.");
                for (int i = 0; i < numThreads; ++i)
                {
                    threads[i].Join();
                }
            }
            finally
            {
                resourceTimer.Close();
            }
        }
    }
}
