﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

using Mischel.Synchronization;

namespace wakeup
{
    class Program
    {
        static void Main(string[] args)
        {
            using (WaitableTimer wt = new WaitableTimer(true))
            {
                int rslt = wt.Change(TimeSpan.FromMinutes(1), 0, WakeupProc, null, true);
                if (rslt == WaitableTimer.ErrorNotSupported)
                {
                    Console.WriteLine("Computer does not support resume.");
                }
                // wait for event to occur
                Console.WriteLine("Waiting for timer to expire");
                wt.WaitOne();

                // Sleep for 5 seconds, which should be
                // enough time for the WakeupProc to do its thing.
                Thread.Sleep(5000);

                Console.Write("Press Enter:");
                Console.ReadLine();
            }
        }

        static void WakeupProc(object state, DateTime eventTime)
        {
            Console.WriteLine("Current time is {0}", DateTime.Now);
            Console.WriteLine("Event fired at {0}", eventTime);
        }
    }
}
